Loading...
Searching...
No Matches
casacore::ArrayIterator< T > Class Template Reference
casa package (libcasa_casa) » Arrays_module

More...

`#include <ArrayIter.h>`

## Public Member Functions

| ArrayIterator (const Array< T > &arr, size_t byDim=1)
| Step through array "arr" over the first byDim axes (using a cursor of dimensionality "byDim").
| ArrayIterator (const Array< T > &arr, const IPosition &axes, bool axesAreCursor=true)
| Step through an array using the given axes.
virtual void | next () override
| Move the cursor to the next position.
virtual void | set (const IPosition &cursorPos) override
| Set the cursor to the given position.
virtual void | reset () override
| Reset the cursor to the beginning.
Array< T > & | array ()
| Return the cursor.
virtual ArrayBase & | getArray () override
| Get the array in the cursor.
Public Member Functions inherited from casacore::ArrayPositionIterator
| ArrayPositionIterator (const IPosition &shape, const IPosition &origin, size_t byDim)
| Define the shape and origin of the volume the cursor will step through.
| ArrayPositionIterator (const IPosition &shape, size_t byDim)
| ArrayPositionIterator (const IPosition &shape, const IPosition &axes, bool axesAreCursor=true)
| Step through an array using the given axes.
virtual | ~ArrayPositionIterator ()
void | origin ()
bool | atStart () const
| Returns true of the cursor is at the origin.
bool | pastEnd () const
| Returns true if the cursor has moved past the end of its volume.
const IPosition & | pos () const
| Return the position of the cursor.
IPosition | endPos () const
| Return the end position of the cursor.
size_t | ndim () const
| What is the dimensionality of the volume we are iterating through?
const IPosition & | iterAxes () const
| Return the iteration axes.
const IPosition & | cursorAxes () const
| Return the cursor axes.

## Protected Attributes

std::unique_ptr< Array< T > > | ap_p
| The cursor.

## Private Member Functions

void | init (const Array< T > &)
| helper function to centralize construction work
void | apSetPointer (int stepDim)
| helper function to set the pointer to the new data position in ap after a step in the given dimension.
| ArrayIterator (const ArrayIterator< T > &)
ArrayIterator< T > & | operator= (const ArrayIterator< T > &)

## Private Attributes

Array< T > | pOriginalArray_p
IPosition | offset_p
T * | dataPtr_p

## Additional Inherited Members

Protected Member Functions inherited from casacore::ArrayPositionIterator
size_t | nextStep ()
| Advance cursor to its next position and tell which dimension stepped.
size_t | dimIter () const
| What is the dimensionality of the "step" the cursor takes, i.e.

## Detailed Description

template<typename T>
class casacore::ArrayIterator< T >

Iterate an Array cursor through another Array.

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

ArrayIterator steps an array section (the "cursor") through an array. The cursor "refers" to storage in the array, so that changing the values in the cursor changes values in the original array. Like with ArrayPositionIterator, the cursor presently only moves through the array from bottom to top in the obvious way; however one may of course iterate through a slice ("array section"). This class is derived from ArrayPositionIterator since it also has a position (the blc of the cursor) which moves through the array volume.

Tip: The origin of the cursor, i;e; the subarray that moves through the larger array, is always zero;

Array<float> to, from;
//... set to and from, check that they are conformant
ArrayIterator toiter(to,1);
ArrayIterator fromiter(from,1);
while (! toiter.pastEnd()) {
toiter.array() = fromiter.array(); // copy vector by vector
toiter.next(); fromiter.next();
}
casacore::ArrayIterator::ArrayIterator
ArrayIterator(const Array< T > &arr, size_t byDim=1)
Step through array "arr" over the first byDim axes (using a cursor of dimensionality "byDim").
casacore::Array
Definition Array.h:155

Definition at line 69 of file ArrayIter.h.

## Constructor & Destructor Documentation

## ArrayIterator() [1/3]

template<typename T>

casacore::ArrayIterator< T >::ArrayIterator | ( | const Array< T > & | arr,
|  | size_t | byDim = 1 )

explicit

Step through array "arr" over the first byDim axes (using a cursor of dimensionality "byDim").

Referenced by ArrayIterator(), and operator=().

## ArrayIterator() [2/3]

template<typename T>

casacore::ArrayIterator< T >::ArrayIterator | ( | const Array< T > & | arr,
|  | const IPosition & | axes,
|  | bool | axesAreCursor = true )

Step through an array using the given axes.

The axes can be given in two ways:

1. axesAreCursor=true means that the axes form the cursor axes. The remaining axes will form the iteration axes. This is the default.
2. axesAreCursor=false means the opposite. In this case the iteration axes can be given in any order.

E.g. when using iteration axes 2,0 for an array with shape [5,3,7], each iteration step returns a cursor (containing the data of axis 1). During the iteration axis 2 will vary most rapidly (as it was given first).

## ArrayIterator() [3/3]

template<typename T>

casacore::ArrayIterator< T >::ArrayIterator | ( | const ArrayIterator< T > & |  | ) |

private

References ArrayIterator().

## Member Function Documentation

## apSetPointer()

template<typename T>

void casacore::ArrayIterator< T >::apSetPointer | ( | int | stepDim | ) |

private

helper function to set the pointer to the new data position in ap after a step in the given dimension.

-1 resets it to the beginning.

## array()

template<typename T>

Array< T > & casacore::ArrayIterator< T >::array | ( |  | ) |

inline

Return the cursor.

(Perhaps we should have a fn() that returns a reference to the original array as well?)

Definition at line 113 of file ArrayIter.h.

References ap_p.

Referenced by casacore::TableExprGroupAggr::getArray(), casacore::TableProxy::record2Array(), and casacore::TableExprNodeSet::toArray().

## getArray()

template<typename T>

virtual ArrayBase & casacore::ArrayIterator< T >::getArray | ( |  | ) |

override virtual

Get the array in the cursor.

This is only implemented in the derived ArrayIterator class. By default it throws an exception.

Reimplemented from casacore::ArrayPositionIterator.

## init()

template<typename T>

void casacore::ArrayIterator< T >::init | ( | const Array< T > & |  | ) |

private

helper function to centralize construction work

## next()

template<typename T>

virtual void casacore::ArrayIterator< T >::next | ( |  | ) |

override virtual

Move the cursor to the next position.

Reimplemented from casacore::ArrayPositionIterator.

Referenced by casacore::TableExprGroupAggr::getArray(), casacore::TableProxy::record2Array(), and casacore::TableExprNodeSet::toArray().

## operator=()

template<typename T>

ArrayIterator< T > & casacore::ArrayIterator< T >::operator= | ( | const ArrayIterator< T > & |  | ) |

private

References ArrayIterator().

## reset()

template<typename T>

virtual void casacore::ArrayIterator< T >::reset | ( |  | ) |

override virtual

Reset the cursor to the beginning.

Reimplemented from casacore::ArrayPositionIterator.

## set()

template<typename T>

virtual void casacore::ArrayIterator< T >::set | ( | const IPosition & | cursorPos | ) |

override virtual

Set the cursor to the given position.

The position can only contain the iteration axes or it can be the full position.
In the first case the position must to be given in the order of the iteration axes as given in the constructor. In the latter case the position must be given in natural order (as given by function pos and only the cursor axes are taken into account.

Reimplemented from casacore::ArrayPositionIterator.

## Member Data Documentation

## ap_p

template<typename T>

std::unique_ptr<Array<T> > casacore::ArrayIterator< T >::ap_p

protected

The cursor.

Definition at line 120 of file ArrayIter.h.

Referenced by array(), casacore::MatrixIterator< T >::matrix(), and casacore::VectorIterator< T >::vector().

## dataPtr_p

template<typename T>

T* casacore::ArrayIterator< T >::dataPtr_p

private

Definition at line 131 of file ArrayIter.h.

## offset_p

template<typename T>

IPosition casacore::ArrayIterator< T >::offset_p

private

Definition at line 130 of file ArrayIter.h.

## pOriginalArray_p

template<typename T>

Array<T> casacore::ArrayIterator< T >::pOriginalArray_p

private

Definition at line 129 of file ArrayIter.h.

The documentation for this class was generated from the following files:

- casa/Arrays/ArrayFwd.h
- casa/Arrays/ArrayIter.h